var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgbggentlemodernpng = new Image();
var imgbgdatepng = new Image();
var imgbgmonthpng = new Image();
var imgwatchhandmonthpng = new Image();
var imgbgsecpng = new Image();
var imgwatchhandsecpng = new Image();
var imgwatchhandminutepng = new Image();
var imgwatchhandminutepng = new Image();
var imgwatchhandhourpng = new Image();
var imgwatchhandhourpng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgbggentlemodernpng.src = "bggentlemodern.png";
    context.drawImage(imgbggentlemodernpng, 0, 0, 360, 480);
    context.restore();
    context.save();

    gImage.src = "Merged_index_gentle_modern.png";
    context.drawImage(gImage, 0, 0, 360, 480);
    context.restore();
    context.save();

    imgbgdatepng.src = "bgdate.png";
    context.drawImage(imgbgdatepng, 246, 226, 94, 27);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "16px Tizen";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = dayOfWeek[date.getDay()];
    context.fillText(text, 273, 239);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "16px Tizen";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 323, 239);
    context.restore();
    context.save();

    imgbgmonthpng.src = "bgmonth.png";
    context.drawImage(imgbgmonthpng, 131, 122, 98, 98);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((date.getMonth() + 1 - 0.000000) / (12.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 170);
    context.rotate(angle);
    imgwatchhandmonthpng.src = "watchhandmonth.png";
    context.drawImage(imgwatchhandmonthpng, -5, -48, 10, 96);
    context.restore();
    context.save();

    imgbgsecpng.src = "bgsec.png";
    context.drawImage(imgbgsecpng, 131, 262, 98, 98);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 310);
    context.rotate(angle);
    imgwatchhandsecpng.src = "watchhandsec.png";
    context.drawImage(imgwatchhandsecpng, -5, -48, 10, 96);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 244);
    context.rotate(angle);
    imgwatchhandminutepng.src = "watchhandminute.png";
    context.globalAlpha = 0.5
    context.drawImage(imgwatchhandminutepng, -14, -180, 28, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 240);
    context.rotate(angle);
    imgwatchhandminutepng.src = "watchhandminute.png";
    context.drawImage(imgwatchhandminutepng, -14, -180, 28, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 244);
    context.rotate(angle);
    imgwatchhandhourpng.src = "watchhandhour.png";
    context.globalAlpha = 0.5
    context.drawImage(imgwatchhandhourpng, -14, -180, 28, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 240);
    context.rotate(angle);
    imgwatchhandhourpng.src = "watchhandhour.png";
    context.drawImage(imgwatchhandhourpng, -14, -180, 28, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
